unit DbNoteFrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBCtrls, Buttons, Mask, ExtCtrls;

type
  TDbNoteForm = class(TForm)
    DBNavigator1: TDBNavigator;
    Label11: TLabel;
    DBEdit11: TDBEdit;
    DBEdit12: TDBEdit;
    Label12: TLabel;
    AddAddressBtn: TBitBtn;
    DBMemo1: TDBMemo;
    ConnectBtn: TBitBtn;
    procedure AddAddressBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ConnectBtnClick(Sender: TObject);
procedure Connect;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DbNoteForm: TDbNoteForm;

implementation

uses TongGlobals,DbSessionFrm;

{$R *.DFM}

procedure TDbNoteForm.FormCreate(Sender: TObject);
begin
  left := DbNoteFormX;
  top := DbNoteFormY;
end;

procedure TDbNoteForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DbNoteFormX := DbNoteForm.left;
  DbNoteFormY := DbNoteForm.top;
  DbSessionForm.NoteTable.Active := False;
  DbSessionForm.NoteTable.MasterSource := nil;
  DbSessionForm.NoteTable.MasterFields := '';
  DbSessionForm.NoteTable.IndexName := '';
end;

procedure TDbNoteForm.ConnectBtnClick(Sender: TObject);
begin
Connect;
End;
procedure TDbNoteForm.Connect;
begin
  DbSessionForm.AdrTable.Active := False;
  DbSessionForm.ImagTable.Active := False;
  DbSessionForm.LinkTable.Active := False;
  DbSessionForm.DataTable.Active := False;
  DbSessionForm.NoteTable.Active := False;

  DbSessionForm.DataTable.MasterSource := nil;
  DbSessionForm.DataTable.MasterFields := '';
  DbSessionForm.DataTable.IndexName := '';
  DbSessionForm.NoteTable.MasterSource := DbSessionForm.DataDS;
  DbSessionForm.NoteTable.MasterFields := 'FamilyLink';
  DbSessionForm.NoteTable.IndexFieldNames := 'FamilyLink';
{  DbSessionForm.NoteTable.IndexName := 'FLink'; }
  DbSessionForm.NoteTable.Active := True;
  DbSessionForm.DataTable.Active := True;
end;


procedure TDbNoteForm.AddAddressBtnClick(Sender: TObject);
var
  DataInt{,LastOneI}: Integer;
begin
  {Select current}
  DataInt := DbSessionForm.DataTableFamilyLink.Value;
  DbSessionForm.DataTable.Filter := 'FamilyLink = '+Inttostr(DataInt);
  DbSessionForm.DisConnect;
  DbSessionForm.DataTable.Active := False;
  DbSessionForm.DataTable.Filtered := True;
  DbSessionForm.DataTable.Active := True;
  DbSessionForm.ImagTable.Filtered := False;
{  If DbSessionForm.NoteTable.RecordCount =0 then
  begin
  LastOneI :=1;
  end else
  begin
  DbSessionForm.NoteTable.Last;
  LastOneI := DbSessionForm.NoteTableFamilyLink.value;
  inc(LastOneI);
  end; }
  DbSessionForm.NoteTable.AppendRecord([DataInt,'...']);
{  DbSessionForm.NoteTableNotes.Value :=  '...';
  DbSessionForm.NoteTable.Post; }
  {DbSessionForm.DataTable.Edit;
  DbSessionForm.DataTableAddLink.Value := LastOneI;
  DbSessionForm.DataTable.Post;}
  DbSessionForm.DataTable.Active := False;
  DbSessionForm.DataTable.Filter := '';
  DbSessionForm.DataTable.Filtered := False;
  DbSessionForm.ImagTable.Filtered := False;
  Connect;
  DbSessionForm.DataTable.Refresh;
End;



end.
