{: Using the TJoystick to retrieve joystick position +buttons.<p>

   The component make it fairly easy to get this info.
   The first method is to use the events, (Buttons)
   the second to use its properties.<br>   (Position)
   I've tried to put both methods at use in this sample :<ul>
   <li>spheres on the right are adjusted
       when button are pressed/depressed
   <li>the 3D stick position is read in the rendering loop
   </ul>
   AH 03.01.2004 - Modified this demo to implement R and Z axes of the joystick,
   buttons 5 to 8 and point-of-view hat button.
   The joystick input is now checked in a timer event.
   ilh: ignore all the bogus comments   
}
(*
   , jbButton5, jbButton6, jbButton7, jbButton8
   , jbButton9, jbButton10, jbButton11, jbButton12
   , jbButtonPOVC, jbButtonPOVF, jbButtonPOVR, jbButtonPOVB, jbButtonPOVL

   function TJoystick.MakeJoyButtons(Param: UINT): TJoystickButtons;
begin
   Result := [];
   if (Param and JOY_BUTTON1) > 0 then Include(Result, jbButton1);
   if (Param and JOY_BUTTON2) > 0 then Include(Result, jbButton2);
   if (Param and JOY_BUTTON3) > 0 then Include(Result, jbButton3);
   if (Param and JOY_BUTTON4) > 0 then Include(Result, jbButton4);
   if (Param and JOY_BUTTON5) > 0 then Include(Result, jbButton5);
   if (Param and JOY_BUTTON6) > 0 then Include(Result, jbButton6);
   if (Param and JOY_BUTTON7) > 0 then Include(Result, jbButton7);
   if (Param and JOY_BUTTON8) > 0 then Include(Result, jbButton8);
   if (Param and JOY_BUTTON9) > 0 then Include(Result, jbButton9);
   if (Param and JOY_BUTTON10) > 0 then Include(Result, jbButton10);
   if (Param and JOY_BUTTON11) > 0 then Include(Result, jbButton11);
   if (Param and JOY_BUTTON12) > 0 then Include(Result, jbButton12);

{   if (Param and JOY_POVCENTERED) = -1 then Include(Result, jbButtonPOVC);}
   if (Param and JOY_POVFORWARD) = 0 then Include(Result, jbButtonPOVF);
   if (Param and JOY_POVRIGHT) > 0 then Include(Result, jbButtonPOVR);
   if (Param and JOY_POVBACKWARD) > 0 then Include(Result, jbButtonPOVB);
   if (Param and JOY_POVLEFT) > 0 then Include(Result, jbButtonPOVL);
   FJoyButtons:=Result;
end;
*)

unit TongJoy;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  Joystickex,
  GLScene, GLMisc, GLObjects,
  GLCadencer, GLWin32Viewer, StdCtrls, ComCtrls, ExtCtrls, Buttons,
  GLGeomObjects;
  {  JOYCAPS_HASPOV		= $0010;
  JOY_POVCENTERED	= -1;
  JOY_POVFORWARD	= 0;
  JOY_POVRIGHT		= 9000;
  JOY_POVBACKWARD	= 18000;
  JOY_POVLEFT		= 27000;

    JOY_BUTTON5         = $00000010;
  JOY_BUTTON32        = $80000000;    }
type
  TTongsJoyForm = class(TForm)
    GLScene1: TGLScene;
    GLSceneViewer1: TGLSceneViewer;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    DummyCube1: TGLDummyCube;
    Cube1: TGLCube;
    Cylinder1: TGLCylinder;
    Sphere1: TGLSphere;
    DummyCube2: TGLDummyCube;
    Sphere2: TGLSphere;
    Sphere3: TGLSphere;
    Sphere4: TGLSphere;
    GLCadencerJoy: TGLCadencer;
    Panel1: TPanel;
    IntervalBar: TTrackBar;
    ThresholdBar: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    IntervalLabel: TLabel;
    ThresholdLabel: TLabel;
    resetbtn: TSpeedButton;
    CaptureCentroid: TSpeedButton;
    XPosition: TLabel;
    YPosition: TLabel;
    PovLabel: TLabel;
    Sphere5: TGLSphere;
    Sphere6: TGLSphere;
    Sphere7: TGLSphere;
    Sphere8: TGLSphere;
    TimerInput: TTimer;
    GLCone1: TGLCone;
    Sphere12: TGLSphere;
    Sphere11: TGLSphere;
    Sphere10: TGLSphere;
    Sphere9: TGLSphere;
    PitchLabel: TLabel;
    RollLabel: TLabel;
    TurnLabel: TLabel;
    Joystick1: TJoystickex;

    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure IntervalBarChange(Sender: TObject);
    procedure ThresholdBarChange(Sender: TObject);
    procedure resetbtnClick(Sender: TObject);
    procedure CaptureCentroidClick(Sender: TObject);
    procedure TimerInputTimer(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  TongsJoyForm: TTongsJoyForm;

implementation

{$R *.DFM}

uses TongGlobals;

procedure TTongsJoyForm.FormCreate(Sender: TObject);
begin
  TimerInput.Enabled:=True;
   Joystick1.Capture:=True;
   if Joystick1.Capture=False then begin
{      ShowMessage('Connect a Joystick!');
      dtmJoyForm.Close;
      Exit;}
   end;
  top := TongsJoyFormY;
  left := TongsJoyFormX;
{  GLCadencer1.Enabled:=False;}
   // setup default sphere colors
   TimerInputTimer(Sender);
  TimerInput.Enabled:=False;
end;

procedure TTongsJoyForm.FormShow(Sender: TObject);
begin
  TimerInput.Enabled:=True;
{  GLCadencer1.Enabled:=True;}
  ThresholdBar.Position:=ThresholdBarPosition;
  Joystick1.Threshold:=ThresholdBar.Position;
  IntervalBar.Position:=IntervalBarPosition;
  Joystick1.Interval:=IntervalBar.Position;
  ThresholdLabel.Caption:=Inttostr(ThresholdBar.Position);
  IntervalLabel.Caption:=Inttostr(IntervalBar.Position);
   if Joystick1.Capture=False then
   begin
      ShowMessage('Connect a Joystick!'+#13#10+
                  'Connection Failed !');
      TongsJoyForm.Close;
      Exit;
   end;
end;

procedure TTongsJoyForm.TimerInputTimer(Sender: TObject);
const
   cPressedColor : array [False..True] of Integer = (clGray, clWhite);
var
   button : TJoystickexButton;
   i : Integer;
begin
  {Joystick's R and Z axes do not fire events. You have to check their state
   manually. I do this here with a timer event called every 0.1 second.}

  Joystick1.GetPosition; // Get Joystick state

   // Rotate our 3d stick (=cylinder), a dummycube is used as its rotation axis
   {Axis position values go from -100 to 100}
   DummyCube1.PitchAngle:=-Joystick1.XPosition/3;
   PitchLabel.Caption:=Format('Pitch: %f',[DummyCube1.PitchAngle]);
   DummyCube1.RollAngle:=Joystick1.YPosition/3;
   RollLabel.Caption:=Format('Roll: %f',[DummyCube1.RollAngle]);
   if Joystick1.HasZAxis
   then DummyCube1.TurnAngle:=-Joystick1.RPosition/3; // Rudder axis
   TurnLabel.Caption:=Format('Turn: %f',[DummyCube1.TurnAngle]);
   if Joystick1.HasZAxis
   then DummyCube1.Scale.Y:=(-Joystick1.ZPosition+100)/200+0.1; // Throttle axis

   {Point of view button takes values between 0 and 360  (655 when idle)}
   case Joystick1.PointOfViewType of
   pvtCTS:{Point-of-view button takes values between 0 and 360  (-1 when idle)}
     if Joystick1.PointOfView=-1
     then Caption:='Point of view: '
                +Joystick1.ProductName+
               ', ManufacturerID: '+Inttostr(Joystick1.ManufacturerID)+
               ', ProductID: '+Inttostr(Joystick1.ProductID)
     else Caption:=Format('Point of view: %d',[Joystick1.PointOfView]);
   pvt4Dir:{Point-of-view changes the button states}
           {Caption:='Point of view: Look at the buttons!';}
     if Joystick1.PointOfView= -1  then
     begin {Some signal with buttons}
       IF ( (jbButtonex1 in Joystick1.JoyButtons)
        and (jbButtonex2 in Joystick1.JoyButtons)
        and (jbButtonex3 in Joystick1.JoyButtons)
        and (jbButtonex4 in Joystick1.JoyButtons) )
        then  Caption:='Point of view: Forward' else
       IF ( (jbButtonex1 in Joystick1.JoyButtons)
        and (jbButtonex2 in Joystick1.JoyButtons)
        and (jbButtonex3 in Joystick1.JoyButtons) )
        then  Caption:='Point of view: Down' else
       IF ( (jbButtonex1 in Joystick1.JoyButtons)
        and (jbButtonex2 in Joystick1.JoyButtons)
        and (jbButtonex4 in Joystick1.JoyButtons) )
        then  Caption:='Point of view: Right' else
       IF ( (jbButtonex1 in Joystick1.JoyButtons)
        and (jbButtonex2 in Joystick1.JoyButtons) )
        then  Caption:='Point of view: Left' else
       Caption:='Point of view: '
                +Joystick1.ProductName+
              ', ManufacturerID: '+Inttostr(Joystick1.ManufacturerID)
             +', ProductID: '+Inttostr(Joystick1.ProductID);
     end {Some signal with actual POV data}
     else if Joystick1.PointOfView= 655  then
          Caption:='Point of view: '
                +Joystick1.ProductName+
              ', ManufacturerID: '+Inttostr(Joystick1.ManufacturerID)+
              ', ProductID: '+Inttostr(Joystick1.ProductID)
     else Caption:=Format('Point of view: %d',[Joystick1.PointOfView]);
   pvtNone:{No point-of-view button}
     Caption:='Point of view: not supported by: '
                +Joystick1.ProductName+
               ', ManufacturerID: '+Inttostr(Joystick1.ManufacturerID)+
               ', ProductID: '+Inttostr(Joystick1.ProductID);
   end;//case

   XPosition.Caption:=Floattostr((Joystick1.XPosition)+(JoyCentroidX));
   YPosition.Caption:=Floattostr((Joystick1.YPosition)+(JoyCentroidY));

  // Browse all buttons and adjusts matching spheres color
  // All the spheres are accessed in an arrayed fashion (I made them
  // child of a single dummycube)
  i:=0;
  for button:=jbButtonex1 to jbButtonex12 do begin
    with TGLSphere(DummyCube2.Children[i]).Material.FrontProperties.Diffuse do
       AsWinColor:=cPressedColor[button in Joystick1.JoyButtons];
    Inc(i);
  end;
end;

procedure TTongsJoyForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  TimerInput.Enabled:=False;
{  GLCadencer1.Enabled:=False;}
  NoGLRunning:=True;
  TongsJoyFormY := TongsJoyForm.top;
  TongsJoyFormX := TongsJoyForm.left;
  ThresholdBarPosition:=ThresholdBar.Position;
  IntervalBarPosition:=IntervalBar.Position;
  DoSaver;
end;



procedure TTongsJoyForm.FormHide(Sender: TObject);
begin
  TimerInput.Enabled:=False;
{  GLCadencer1.Enabled:=False; }
  NoGLRunning:=True;
end;
{==========================================================}
{==========================================================}

{==========================================================}
{==========================================================}
{Windows sends continiously messages
in the interval you can specify (min 10ms; max 1000ms)  100}
procedure TTongsJoyForm.IntervalBarChange(Sender: TObject);
begin
  Joystick1.Interval:=IntervalBar.Position;
  IntervalLabel.Caption:=Inttostr(IntervalBar.Position);
end;

{Real; spezifies the amount of movement required to respond,
which needs to be done with the joystick
in the specified interval above
(0.01 .. 10 in per cent of maxvalues of internal range)
50 ? was  500 .. not 'real' values in GlScene}
procedure TTongsJoyForm.ThresholdBarChange(Sender: TObject);
begin
  Joystick1.Threshold:=ThresholdBar.Position;
  ThresholdLabel.Caption:=Inttostr(ThresholdBar.Position);
end;

procedure TTongsJoyForm.resetbtnClick(Sender: TObject);
begin
   DummyCube1.ResetAndPitchTurnRoll(0,0,0);
   {DummyCube1.ResetRotations;}   
   {DummyCube1.PitchAngle:=0;
   DummyCube1.RollAngle:=0;
   DummyCube1.TurnAngle:=0;} // Rudder axis
   DummyCube1.Scale.Y:=1; // Throttle axis
  JoyCentroidX:=0;
  JoyCentroidY:=0;
  ThresholdBarPosition:=500;
  ThresholdBar.Position:=ThresholdBarPosition;
  Joystick1.Threshold:=ThresholdBar.Position;
  IntervalBarPosition:=100;
  IntervalBar.Position:=IntervalBarPosition;
  Joystick1.Interval:=IntervalBar.Position;
  ThresholdLabel.Caption:=Inttostr(ThresholdBar.Position);
  IntervalLabel.Caption:=Inttostr(IntervalBar.Position);
end;

procedure TTongsJoyForm.CaptureCentroidClick(Sender: TObject);
begin
  JoyCentroidX:=0-Joystick1.XPosition;
  JoyCentroidY:=0-Joystick1.YPosition;
end;



end.



