{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit gUPixAl;
{This is ALL Pixels... SHOULD use LUT for ALL these...}
interface
{ Place a USES declaration here }
uses
  Windows, Messages, SysUtils, Classes, Graphics,
  gGlobal, Controls, Forms, Dialogs,
  StdCtrls, {WinTypes,} Buttons;
{ Place CONST, TYPE, and VAR declarations here }
{ Place PROCEDURE and FUNCTION declarations here }
procedure Do_PixelAlgebra(Choices: Array13I);

procedure Do_Pixel(ThePixel: Byte);

procedure Do_Gamma(AutoTimes, WhatGamma: Integer; Gamma, Gamma2:
  Double);

procedure Do_PMultiply(RedPixel, GreenPixel, BluePixel: Double;
  TypeOP: Integer);
procedure Do_PARBMultiply(dPARR1, dPARR2, dPARR3,
  dPARG1, dPARG2, dPARG3,
  dPARB1, dPARB2, dPARB3: Double; TypeOP: Integer);
procedure DoContrast(AdjustValue: Integer);
procedure DoPixel;
implementation
{ Place a second USES declaration here }
{ Place private LABEL, CONST, TYPE, and VAR declarations here }
{ Place PROCEDURE and FUNCTION bodies here }

procedure Do_PixelAlgebra(Choices: Array13I);
var
  SpatError: Boolean;
  R_Min: Single;
  R_Range, R_Max,
{Ri, Gi,Bi,K_Filtered, }
  O_Filtered, A_Filtered, AA_Filtered, BA_Filtered, BAA_Filtered,
    R_Filtered, G_Filtered, B_Filtered: Double;
 { R_Hope, G_Hope, B_Hope,CenterPixel, TheColor:Longint;}
{  RCenter, GCenter, BCenter,}
  RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd, Range,
    AutoTimes, Center, Size, sX, sY, Where: Integer;
  IL, IW: DWord;
begin {Get current Window DC}
  AutoTimes := 0;
  if AUTORANGE then AutoTimes := 1;
  SpatError := FALSE;
  R_Max := 0;
  R_Min := 255;
     {Begin of Whole Autorange = True... Do Twice}
  ILStart := 0;
  IWStart := 0;
  ILEnd := (ImageHeight);
  IWEnd := (ImageWidth);
  MakeImage;
  if ImageMade = TRUE then begin
    for RANGE := 0 to AutoTimes do begin
      R_Range := R_Max - R_Min;
      R_Range := R_Range / 255;

      for IL := ILStart to ILEnd do begin
        if R_Max > All_Max then All_Max := R_Max;
        if R_Min < All_Min then All_Min := R_Min;
        for IW := IWStart to IWEnd do begin
          R_Filtered := 0; O_Filtered := 0;
          G_Filtered := 0; A_Filtered := 0;
          B_Filtered := 0; BA_Filtered := 0; AA_Filtered := 0;
       {  TheColor:= GetPixel(hUnDoDC,(IW),(IL));
         RedColor:= GetRValue(TheColor);
         GreenColor:= GetGValue(TheColor);
         BlueColor:= GetBValue(TheColor);}
          WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
          lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
          lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
          lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
          BlueColor := lpPixelB^;
          GreenColor := lpPixelG^;
          RedColor := lpPixelR^;
{Ratios make Gray images..
Red is used for 1 channel
Green for 2
and Blue for 3
to Combine them into the image:
O_Filtered,A_Filtered,AA_Filtered,BA_Filtered,BAA_Filtered,
where RGB are the same value}
 {Do_Pixel Algebra}{it Does Auto, NDVI, ClipB<> }

{AOPArray[A,B,Op,AG1,AG2,AG3,AO1,AO2,BG1,BG2,BG3,BO1,BO2]}
          case Choices[1] {A} of
            0: begin
                case Choices[4] of
                  0: A_Filtered := RedColor + 0.00001;
                  1: A_Filtered := GreenColor + 0.00001;
                  2: A_Filtered := BlueColor + 0.00001;
                end; {inner case} end;
            1: begin
                case Choices[4] of
                  0: R_Filtered := RedColor + 0.00001;
                  1: R_Filtered := GreenColor + 0.00001;
                  2: R_Filtered := BlueColor + 0.00001;
                end; {inner case}
                case Choices[5] of
                  0: G_Filtered := RedColor + 0.00001;
                  1: G_Filtered := GreenColor + 0.00001;
                  2: G_Filtered := BlueColor + 0.00001;
                end; {inner case}
                case Choices[7] of
                  0: A_Filtered := (R_Filtered + G_Filtered);
                  1: begin A_Filtered := (R_Filtered - G_Filtered);
                      if (A_Filtered = 0) then
                        A_Filtered := 0.00001; end;
                  2: A_Filtered := (R_Filtered * G_Filtered);
                  3: A_Filtered := (R_Filtered / G_Filtered);
                end; {inner case}
              end;
            2: begin
                case Choices[4] of
                  0: R_Filtered := RedColor + 0.00001;
                  1: R_Filtered := GreenColor + 0.00001;
                  2: R_Filtered := BlueColor + 0.00001;
                end; {inner case}
                case Choices[5] of
                  0: G_Filtered := RedColor + 0.00001;
                  1: G_Filtered := GreenColor + 0.00001;
                  2: G_Filtered := BlueColor + 0.00001;
                end; {inner case}
                case Choices[6] of
                  0: B_Filtered := RedColor + 0.00001;
                  1: B_Filtered := GreenColor + 0.00001;
                  2: B_Filtered := BlueColor + 0.00001;
                end; {inner case}
                case Choices[7] of
                  0: AA_Filtered := (R_Filtered + G_Filtered);
                  1: begin AA_Filtered := (R_Filtered - G_Filtered);
                      if (AA_Filtered = 0) then
                        AA_Filtered := 0.00001; end;
                  2: AA_Filtered := (R_Filtered * G_Filtered);
                  3: AA_Filtered := (R_Filtered / G_Filtered);
                end; {inner case}
                case Choices[8] of
                  0: A_Filtered := (AA_Filtered + B_Filtered);
                  1: begin A_Filtered := (AA_Filtered - B_Filtered);
                      if (A_Filtered = 0) then
                        A_Filtered := 0.00001; end;
                  2: A_Filtered := (AA_Filtered * B_Filtered);
                  3: A_Filtered := (AA_Filtered / B_Filtered);
                end; {inner case}
{AOPArray[A,B,Op,AG1,AG2,AG3,AO1,AO2,BG1,BG2,BG3,BO1,BO2]}
              end; {CASE 2}
          end; {Case A}
          case Choices[2] {B} of
            0: begin
                case Choices[9] of
                  0: BA_Filtered := RedColor + 0.00001;
                  1: BA_Filtered := GreenColor + 0.00001;
                  2: BA_Filtered := BlueColor + 0.00001;
                end; {inner case} end;
            1: begin
                case Choices[9] of
                  0: R_Filtered := RedColor + 0.00001;
                  1: R_Filtered := GreenColor + 0.00001;
                  2: R_Filtered := BlueColor + 0.00001;
                end; {inner case}
                case Choices[10] of
                  0: G_Filtered := RedColor + 0.00001;
                  1: G_Filtered := GreenColor + 0.00001;
                  2: G_Filtered := BlueColor + 0.00001;
                end; {inner case}
                case Choices[12] of
                  0: BA_Filtered := (R_Filtered + G_Filtered);
                  1: begin BA_Filtered := (R_Filtered - G_Filtered);
                      if (BA_Filtered = 0) then
                        BA_Filtered := 0.00001; end;
                  2: BA_Filtered := (R_Filtered * G_Filtered);
                  3: BA_Filtered := (R_Filtered / G_Filtered);
                end; {inner case}
              end;
            2: begin
                case Choices[9] of
                  0: R_Filtered := RedColor + 0.00001;
                  1: R_Filtered := GreenColor + 0.00001;
                  2: R_Filtered := BlueColor + 0.00001;
                end; {inner case}
                case Choices[10] of
                  0: G_Filtered := RedColor + 0.00001;
                  1: G_Filtered := GreenColor + 0.00001;
                  2: G_Filtered := BlueColor + 0.00001;
                end; {inner case}
                case Choices[11] of
                  0: B_Filtered := RedColor + 0.00001;
                  1: B_Filtered := GreenColor + 0.00001;
                  2: B_Filtered := BlueColor + 0.00001;
                end; {inner case}
                case Choices[12] of
                  0: BAA_Filtered := (R_Filtered + G_Filtered);
                  1: begin BAA_Filtered := (R_Filtered - G_Filtered);
                      if (BAA_Filtered = 0) then
                        BAA_Filtered := 0.00001; end;
                  2: BAA_Filtered := (R_Filtered * G_Filtered);
                  3: BAA_Filtered := (R_Filtered / G_Filtered);
                end; {inner case}
                case Choices[13] of
                  0: BA_Filtered := (BAA_Filtered + B_Filtered);
                  1: begin BA_Filtered := (BAA_Filtered -
                        B_Filtered);
                      if (BA_Filtered = 0) then
                        BA_Filtered := 0.00001; end;
                  2: BA_Filtered := (BAA_Filtered * B_Filtered);
                  3: BA_Filtered := (BAA_Filtered / B_Filtered);
                end; {inner case}
{AOPArray[A,B,Op,AG1,AG2,AG3,AO1,AO2,BG1,BG2,BG3,BO1,BO2]}
              end; {CASE 2}
          end; {Case A}
          case Choices[3] {OP} of
            0: O_Filtered := (A_Filtered + BA_Filtered);
            1: O_Filtered := (A_Filtered - BA_Filtered);
            2: O_Filtered := (A_Filtered * BA_Filtered);
            3: O_Filtered := (A_Filtered / BA_Filtered);
          end; {inner case}

          if AUTORANGE then begin
            if Range = 0 then begin
              if O_Filtered > R_Max then R_Max := O_Filtered;
              if O_Filtered < R_Min then R_Min := O_Filtered;
            end;
            if Range = 1 then begin
(*       R_Filtered :=  (R_Filtered+{ABS}(R_Min))/R_Range;
       G_Filtered :=  (G_Filtered+{ABS}(G_Min))/G_Range;
       B_Filtered :=  (B_Filtered+{ABS}(B_Min))/B_Range;
*)
              O_Filtered := ((O_Filtered - (R_Min)) / R_Range);
              if O_Filtered > 255 then O_Filtered := 255;
              if O_Filtered < 0 then O_Filtered := 0;
              RedColor := Round(O_Filtered);
              GreenColor := Round(O_Filtered);
              BlueColor := Round(O_Filtered);
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;

            end;
          end else
            if {Do_Absolute, AutoRange, B_Ex_com}  BelowZero
              {, ClipR, ThresholdR,}
            then begin {Jensen, p. 136}
{       IF R_Filtered <= 0 then R_Filtered := (127+(R_Filtered*127) ) else
       IF R_Filtered > 0 then} O_Filtered := (127 + (O_Filtered *
                127));
              if O_Filtered > 255 then O_Filtered := 255;
              if O_Filtered < 0 then O_Filtered := 0;
              RedColor := Round(O_Filtered);
              GreenColor := Round(O_Filtered);
              BlueColor := Round(O_Filtered);
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;

            end else
              if {Do_Absolute, AutoRange, }  Do_Ex_com
                {, ClipR, ThresholdR,}
              then begin {Jensen, p. 136}
                if O_Filtered < 1 then
                  O_Filtered := ((O_Filtered * 127) + 1) else
                  if O_Filtered >= 1 then
                    O_Filtered := (128 + (O_Filtered / 2));
                if O_Filtered > 255 then O_Filtered := 255;
                if O_Filtered < 0 then O_Filtered := 0;
                RedColor := Round(O_Filtered);
                GreenColor := Round(O_Filtered);
                BlueColor := Round(O_Filtered);
                WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
                lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                lpPixelR^ := RedColor;

              end else
                if {Do_Absolute, AutoRange, B_Ex_com,}  ClipR
                  {, ThresholdR,}
                then begin {Jensen, p. 136}
                  if O_Filtered > 255 then O_Filtered := 255;
                  if O_Filtered < 0 then O_Filtered := 0;
                  RedColor := Round(O_Filtered);
                  GreenColor := Round(O_Filtered);
                  BlueColor := Round(O_Filtered);
                  WherePixel := ((IW * 3) + (IL * BytesPerLine));
                  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                  lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                    1];
                  lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                    2];
                  lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                  lpPixelR^ := RedColor;

                end; { of AutoRange Insider Edition}
        end; {of  Image Width}
       {Place a Window Breather;
        and an Update IconWait message here}
        if AutoRange then begin
          if (Range = 0) then
          begin
            Per_Done := Round(100 * (IL / (ImageHeight)));
            SetP_Done(1, Per_Done
              {inWindow: HWND; iPercentDone: integer}, All_Min,
              All_Max);
          end else
            if (Range = 1) then
            begin
              Per_Done := Round(100 * (IL / (ImageHeight)));
              SetP_Done(2, Per_Done
                {inWindow: HWND; iPercentDone: integer}, All_Min,
                All_Max);
            end
        end else
        begin
          Per_Done := Round(100 * (IL / (ImageHeight)));
          SetP_Done1(Per_Done);
        end;
      end; {of Image Length}
    end; {of AutoRange}
{BlackOut;}
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
end; {of Pixel Algebra}
(******************************************************)

procedure Do_Pixel(ThePixel: Byte);
var
  SpatError: Boolean;
  R_Min, G_Min, B_Min: Single;
  R_Range, R_Max, G_Range, G_Max, B_Range, B_Max,
    Ri, Gi, Bi, K_Filtered, R_Filtered, G_Filtered, B_Filtered:
  Double;
{  R_Hope, G_Hope, B_Hope,CenterPixel, TheColor:Longint;}
{  RCenter, GCenter, BCenter,}
  RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd, Range,
    AutoTimes, {Center, } Size, sX, sY, Where: Integer;
  IL, IW: DWord;
begin {Get current Window DC}
  AutoTimes := 0;
  if AUTORANGE then AutoTimes := 1;
  SpatError := FALSE;
  R_Max := 0;
  R_Min := 255;
  G_Max := 0;
  G_Min := 255;
  B_Max := 0;
  B_Min := 255;
     {Begin of Whole Autorange = True... Do Twice}
  ILStart := 0;
  IWStart := 0;
  ILEnd := (ImageHeight);
  IWEnd := (ImageWidth);
  MakeImage;
  if ImageMade = TRUE then begin
    for RANGE := 0 to AutoTimes do begin
      R_Range := R_Max - R_Min;
      R_Range := R_Range / 255;
      G_Range := G_Max - G_Min;
      G_Range := G_Range / 255;
      B_Range := B_Max - B_Min;
      B_Range := B_Range / 255;

      for IL := ILStart to ILEnd do begin
        if R_Max > All_Max then All_Max := R_Max;
        if G_Max > All_Max then All_Max := G_Max;
        if B_Max > All_Max then All_Max := B_Max;
        if R_Min < All_Min then All_Min := R_Min;
        if G_Min < All_Min then All_Min := G_Min;
        if B_Min < All_Min then All_Min := B_Min;
        for IW := IWStart to IWEnd do begin
          R_Filtered := 0;
          G_Filtered := 0;
          B_Filtered := 0;
       {  TheColor:= GetPixel(hUnDoDC,(IW),(IL));
         RedColor:= GetRValue(TheColor);
         GreenColor:= GetGValue(TheColor);
         BlueColor:= GetBValue(TheColor);}
          WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
          lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
          lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
          lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
          BlueColor := lpPixelB^;
          GreenColor := lpPixelG^;
          RedColor := lpPixelR^;

 {Do_Pixel Algebra}{it Does Auto, NDVI, ClipB<> }
          if ThePixel = 1 then {AI  CIRVI} {CIRVI Grey}
          begin
            R_Filtered := ((RedColor - GreenColor + 0.0001) /
              (RedColor + GreenColor + 0.0001));
            G_Filtered := R_Filtered;
            B_Filtered := R_Filtered;
          end else
            if ThePixel = 2 then {AJ  X0 = c/All} {It/All}
            begin {IR Pink else bluish}
              R_Filtered := ((RedColor + 0.0001) / (RedColor +
                GreenColor + BlueColor + 0.0001));
              G_Filtered := ((GreenColor + 0.0001) / (RedColor +
                GreenColor + BlueColor + 0.0001));
              B_Filtered := ((BlueColor + 0.0001) / (RedColor +
                GreenColor + BlueColor + 0.0001));
{ R_Filtered := ((RedColor)   /(BlueColor +GreenColor +0.1));
  G_Filtered := ((GreenColor )/(RedColor +BlueColor +0.1));
  B_Filtered := ((BlueColor ) /(RedColor +GreenColor +0.1));}
            end else

              if ThePixel = 3 then {AK  X1 = A-B / A+B} {3 VI}
              begin {Soil is dark, IR is light, lake green, rest purple}
                R_Filtered := ((RedColor + 0.0001) / (GreenColor +
                  BlueColor + 0.0001));
                G_Filtered := ((RedColor - GreenColor + 0.0001) /
                  (RedColor + GreenColor + 0.0001));
                B_Filtered := ((RedColor - BlueColor + 0.0001) /
                  (RedColor + BlueColor + 0.0001));
              end else

                if ThePixel = 4 then {AK  X2 = A-B / A/B} {3 DIVI}
                begin {IR Blue, Soil black, Horseshoe green}
                  R_Filtered := ((GreenColor - BlueColor + 0.0001) /
                    (GreenColor / (BlueColor + 0.0001)));
                  G_Filtered := ((RedColor - GreenColor + 0.0001) /
                    (RedColor / (GreenColor + 0.0001)));
                  B_Filtered := ((RedColor - BlueColor + 0.0001) /
                    (RedColor / (BlueColor + 0.0001)));
                end else

                  if ThePixel = 5 then
                    {AL  X3 = A+b / a-c}{Inverse 3 VI}{SAME AS 3 DIVI.???}
                  begin {Larger-smaller could be done...but that changes the inherent relation}
                    R_Filtered := ((RedColor + 0.0001) / (GreenColor
                      - BlueColor + 0.0001));
                    G_Filtered := ((RedColor + GreenColor + 0.0001) /
                      (RedColor - GreenColor + 0.0001));
                    B_Filtered := ((RedColor + BlueColor + 0.0001) /
                      (RedColor - BlueColor + 0.0001));
                  end else
                    if ThePixel = 6 then {AQ  X4 a/b } {Old elated}
                    begin {Soil is brown, lake yellow, IR&Forest whiteout}
                      R_Filtered := ((RedColor + GreenColor + 0.0001)
                        / (BlueColor + 0.0001));
                      G_Filtered := ((RedColor + 0.0001) / (GreenColor
                        + 0.0001));
                      B_Filtered := ((RedColor + 0.0001) / (BlueColor
                        + 0.0001));
                    end else

                      if ThePixel = 7 then
                        {AN  X5 = a+b /c}{OTHER 2 / IT}
                      begin {NDVI: IR Cyan else white; AUTO: IR cyan, Red soil, else dark blue}
                        R_Filtered := ((BlueColor + GreenColor +
                          0.0001) / (RedColor + 0.0001));
                        G_Filtered := ((RedColor + BlueColor + 0.0001)
                          / (GreenColor + 0.0001));
                        B_Filtered := ((RedColor + GreenColor +
                          0.0001) / (BlueColor + 0.0001));
                      end else

                        if ThePixel = 8 then
                          {AJ  X6 = All /x}{All / It}
                        begin {NDVI Whiteout; AUTO: }
                          R_Filtered := ((RedColor + GreenColor +
                            BlueColor + 0.0001) / (RedColor +
                              0.0001));
                          G_Filtered := ((RedColor + GreenColor +
                            BlueColor + 0.0001) / (GreenColor +
                            0.0001));
                          B_Filtered := ((RedColor + GreenColor +
                            BlueColor + 0.0001) / (BlueColor +
                            0.0001));
                        end else

                          if ThePixel = 9 then
                            {AP  X7 = A+C/Blue}{ OTHER2/Blue}
                          begin {NDVI Whiteout; AUTO: }
                            R_Filtered := ((RedColor + BlueColor +
                              0.0001) / (BlueColor + 0.0001));
                            G_Filtered := ((GreenColor + BlueColor +
                              0.0001) / (BlueColor + 0.0001));
                            B_Filtered := ((RedColor + GreenColor +
                              0.0001) / (BlueColor + 0.0001));
{  R_Filtered := ((RedColor + BlueColor)  /(GreenColor+0.1));
  G_Filtered := ((GreenColor + BlueColor)/(GreenColor+0.1));
  B_Filtered := ((RedColor + GreenColor) /(GreenColor+0.1));}
{  R_Filtered := ((RedColor + BlueColor)  /(RedColor+0.1));
  G_Filtered := ((GreenColor + BlueColor)/(RedColor+0.1));
  B_Filtered := ((RedColor + GreenColor) /(RedColor+0.1));}
                          end else
                            if ThePixel = 10 then
                              {AL  X8 = A+b / a*c}{3MVI2Real}
                            begin {NDVI Whiteout; AUTO: }
                              Ri := RedColor; Gi := GreenColor; Bi :=
                              BlueColor;
                              R_Filtered := ((Ri + 0.0001) / ((Gi *
                                Bi) + 0.0001));
                              G_Filtered := ((Ri + Gi + 0.0001) / ((Ri
                                * Gi) + 0.0001));
                              B_Filtered := ((Ri + Bi + 0.0001) / ((Ri
                                * Bi) + 0.0001));
                            end else
                              if ThePixel = 11 then
                                {AO  X9 = a*b /c}{((OTHER1 * OTHER1) / IT)}
                              begin {Weird... Do changing the Color to a number before the math...}
{NDVI Whiteout; AUTO: }
                                Ri := RedColor; Gi := GreenColor; Bi
                                := BlueColor;
                                R_Filtered := (((Bi * Gi) + 0.0001) /
                                  (Ri + 0.1));
                                G_Filtered := (((Ri * Bi) + 0.0001) /
                                  (Gi + 0.1));
                                B_Filtered := (((Ri * Gi) + 0.0001) /
                                  (Bi + 0.1));
                              end else
                                if ThePixel = 12 then
                                  {AL  X10 = A+b / a*c}{3MVI2Real}
                                begin {NDVI Whiteout; AUTO: }
                                  Ri := RedColor; Gi := GreenColor; Bi
                                  := BlueColor;
                                  R_Filtered := ((Gi + Bi + 0.0001) /
                                    ((Gi * Bi) + 0.0001));
                                  G_Filtered := ((Ri + Gi + 0.0001) /
                                    ((Ri * Gi) + 0.0001));
                                  B_Filtered := ((Ri + Bi + 0.0001) /
                                    ((Ri * Bi) + 0.0001));
(*Begin{NDVI Whiteout; AUTO: }{}
Ri:= RedColor; Gi:= GreenColor; Bi:=BlueColor;
  R_Filtered :=  ((Gi * Bi) / (Gi /(Bi+0.1)));
  G_Filtered :=  ((Ri * Gi) / (Ri /(Gi +0.1)));
  B_Filtered :=  ((Ri * Bi) / (Ri /(Bi +0.1)));
end;*)
                                end else
                                  if ThePixel = 13 then
                                    {AK  X11 Multiple even}{}
                                  begin
(*  R_Filtered := ((BlueColor * GreenColor) /(RedColor +0.1));
  G_Filtered := ((RedColor  * BlueColor)  /(GreenColor +0.1));
  B_Filtered := ((RedColor  * GreenColor) /(BlueColor +0.1));
  If  (not( (R_Filtered <= 0) and (G_Filtered <=0)
             and (B_Filtered <=0) )) then
begin
  *) if (RedColor > (BlueColor + GreenColor)) then
                                    begin
                                      R_Filtered := RedColor;
                                      G_Filtered := 255;
                                      B_Filtered := 255;
                                    end else
                                    begin
                                      R_Filtered := 255 {RedColor};
                                      G_Filtered := 255 {GreenColor};
                                      B_Filtered := 255 {BlueColor};
                                    end;
                                  end else
                                    if ThePixel = 14 then
                                      {AK  X71 Multiple even}{}
                                    begin
                                      if (GreenColor > (BlueColor +
                                        RedColor)) then
                                      begin
                                        R_Filtered := 255;
                                        G_Filtered := GreenColor;
                                        B_Filtered := 255;
                                      end else
                                      begin
                                        R_Filtered := 255 {RedColor};
                                        G_Filtered := 255
                                          {GreenColor};
                                        B_Filtered := 255
                                          {BlueColor};
                                      end;
                                    end else
                                      if ThePixel = 15 then
                                        {AK  X15 Multiple even}{}
                                      begin
                                        if (BlueColor > (RedColor +
                                          GreenColor)) then
                                        begin
                                          R_Filtered := 255;
                                          G_Filtered := 255;
                                          B_Filtered := BlueColor;
                                        end else
                                        begin
                                          R_Filtered := 255
                                            {RedColor};
                                          G_Filtered := 255
                                            {GreenColor};
                                          B_Filtered := 255
                                            {BlueColor};
                                        end;
                                      end;
(*end;*)

          if AUTORANGE then begin
            if Range = 0 then begin
              if R_Filtered > R_Max then R_Max := R_Filtered;
              if G_Filtered > G_Max then G_Max := G_Filtered;
              if B_Filtered > B_Max then B_Max := B_Filtered;
              if R_Filtered < R_Min then R_Min := R_Filtered;
              if G_Filtered < G_Min then G_Min := G_Filtered;
              if B_Filtered < B_Min then B_Min := B_Filtered;
            end;
            if Range = 1 then begin
(*       R_Filtered :=  (R_Filtered+{ABS}(R_Min))/R_Range;
       G_Filtered :=  (G_Filtered+{ABS}(G_Min))/G_Range;
       B_Filtered :=  (B_Filtered+{ABS}(B_Min))/B_Range;
*)
              R_Filtered := ((R_Filtered - (R_Min)) / R_Range);
              G_Filtered := ((G_Filtered - (G_Min)) / G_Range);
              B_Filtered := ((B_Filtered - (B_Min)) / B_Range);

              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);

{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));}
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;

            end;
          end else
            if {Do_Absolute, AutoRange, B_Ex_com}  BelowZero
              {, ClipR, ThresholdR,}
            then begin {Jensen, p. 136}
{       IF R_Filtered <= 0 then R_Filtered := (127+(R_Filtered*127) ) else
       IF R_Filtered > 0 then} R_Filtered := (127 + (R_Filtered *
                127));
              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);
{       IF G_Filtered <= 0 then G_Filtered := (127+(G_Filtered*127)) else
       IF G_Filtered > 0 then} G_Filtered := (127 + (G_Filtered *
                127));
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);
{       IF B_Filtered <= 0 then B_Filtered := (127+(B_Filtered*127)) else
       IF B_Filtered > 0 then} B_Filtered := (127 + (B_Filtered *
                127));
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));}
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;

            end else
              if {Do_Absolute, AutoRange, }  Do_Ex_com
                {, ClipR, ThresholdR,}
              then begin {Jensen, p. 136}
                if R_Filtered < 1 then
                  R_Filtered := ((R_Filtered * 127) + 1) else
                  if R_Filtered >= 1 then
                    R_Filtered := (128 + (R_Filtered / 2));
                if R_Filtered > 255 then R_Filtered := 255;
                if R_Filtered < 0 then R_Filtered := 0;
                RedColor := Round(R_Filtered);
                if G_Filtered < 1 then
                  G_Filtered := ((G_Filtered * 127) + 1) else
                  if G_Filtered >= 1 then
                    G_Filtered := (128 + (G_Filtered / 2));
                if G_Filtered > 255 then G_Filtered := 255;
                if G_Filtered < 0 then G_Filtered := 0;
                GreenColor := Round(G_Filtered);
                if B_Filtered < 1 then
                  B_Filtered := ((B_Filtered * 127) + 1) else
                  if B_Filtered >= 1 then
                    B_Filtered := (128 + (B_Filtered / 2));
                if B_Filtered > 255 then B_Filtered := 255;
                if B_Filtered < 0 then B_Filtered := 0;
                BlueColor := Round(B_Filtered);
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));}
                WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
                lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                lpPixelR^ := RedColor;

              end else
                if {Do_Absolute, AutoRange, B_Ex_com,}  ClipR
                  {, ThresholdR,}
                then begin {Jensen, p. 136}
                  if R_Filtered > 255 then R_Filtered := 255;
                  if R_Filtered < 0 then R_Filtered := 0;
                  RedColor := Round(R_Filtered);
                  if G_Filtered > 255 then G_Filtered := 255;
                  if G_Filtered < 0 then G_Filtered := 0;
                  GreenColor := Round(G_Filtered);
                  if B_Filtered > 255 then B_Filtered := 255;
                  if B_Filtered < 0 then B_Filtered := 0;
                  BlueColor := Round(B_Filtered);
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));}
                  WherePixel := ((IW * 3) + (IL * BytesPerLine));
                  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                  lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                    1];
                  lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                    2];
                  lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                  lpPixelR^ := RedColor;

                end; { of AutoRange Insider Edition}
        end; {of  Image Width}
       {Place a Window Breather;
        and an Update IconWait message here}
        if AutoRange then begin
          if (Range = 0) then
          begin
            Per_Done := Round(100 * (IL / (ImageHeight)));
            SetP_Done(1, Per_Done
              {inWindow: HWND; iPercentDone: integer}, All_Min,
              All_Max);
          end else
            if (Range = 1) then
            begin
              Per_Done := Round(100 * (IL / (ImageHeight)));
              SetP_Done(2, Per_Done
                {inWindow: HWND; iPercentDone: integer}, All_Min,
                All_Max);
            end
        end else
        begin
          Per_Done := Round(100 * (IL / (ImageHeight)));
          SetP_Done1(Per_Done);
        end;
      end; {of Image Length}
    end; {of AutoRange}
{BlackOut;}
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
end; {of Pixel Ratio}


(******************************************************)
{Redone to be Gamma - Log only}
{Gamma; actually a histogram type correction: Watkins page 132}
(******************************************************)

procedure Do_Gamma(AutoTimes, WhatGamma: Integer; Gamma, Gamma2:
  Double);
var
  RedIn, GreenIn, BlueIn, R_Min, G_Min, B_Min,
    R_Range, R_Max, G_Range, G_Max, B_Range, B_Max,
    R_Filtered2, G_Filtered2, B_Filtered2,
    R_Filtered, G_Filtered, B_Filtered: Double;
  R_Hope, G_Hope, B_Hope, TheColor: Longint;
  RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd, Range, FLength, FWidth,
    ErrorPos, sX, sY, Where: Integer;
  IL, IW: DWord;
begin {Get current Window DC}
  R_Max := 0;
  R_Min := 255;
  G_Max := 0;
  G_Min := 255;
  B_Max := 0;
  B_Min := 255;
  ILStart := (0);
  IWStart := (0);
  ILEnd := (ImageHeight);
  IWEnd := (ImageWidth);
  MakeImage;
  if ImageMade = TRUE then begin
    for RANGE := 0 to AutoTimes do begin
      R_Range := R_Max - R_Min;
      R_Range := R_Range / 255; {or 256?}
      G_Range := G_Max - G_Min;
      G_Range := G_Range / 255;
      B_Range := B_Max - B_Min;
      B_Range := B_Range / 255;
      for IL := ILStart to ILEnd do begin
        if R_Max > All_Max then All_Max := R_Max;
        if G_Max > All_Max then All_Max := G_Max;
        if B_Max > All_Max then All_Max := B_Max;
        if R_Min < All_Min then All_Min := R_Min;
        if G_Min < All_Min then All_Min := G_Min;
        if B_Min < All_Min then All_Min := B_Min;
        for IW := IWStart to IWEnd do begin
          R_Filtered := 0;
          G_Filtered := 0;
          B_Filtered := 0;
{       R_Filtered2 := 0;
       G_Filtered2 := 0;
       B_Filtered2 := 0;}
{         TheColor:= GetPixel(hUnDoDC,IW,IL);
         RedColor:= GetRValue(TheColor);
         RedIn := RedColor;
         BlueColor:= GetBValue(TheColor);
         BlueIn := BlueColor;
         GreenColor:= GetGValue(TheColor);
         GreenIn := GreenColor;}
          WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
          lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
          lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
          lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
          BlueColor := lpPixelB^;
          GreenColor := lpPixelG^;
          RedColor := lpPixelR^;
          if BlueColor = 0 then BlueColor := 1;
          if GreenColor = 0 then GreenColor := 1;
          if RedColor = 0 then RedColor := 1;
          GreenIn := GreenColor; RedIn := RedColor; BlueIn :=
          BlueColor;
{Watkins, p. 61-63,115-116,131,147,159
Code in file:}
          case WhatGamma of
{Contrast      AdjustValue := 55;}
{      Blue  := (lpPixelB^ ) + AdjustValue;
      Green := (lpPixelG^ ) + AdjustValue;
      Red   := (lpPixelR^ ) + AdjustValue;}
            1: begin
                R_Filtered := ((exp(ln(RedIn) / Gamma)) * 10.0);
                G_Filtered := ((exp(ln(GreenIn) / Gamma)) * 10.0);
                B_Filtered := ((exp(ln(BlueIn) / Gamma)) * 10.0);
              end;
            2: begin
                R_Filtered := ((exp(ln(RedIn) / Gamma)) * 10.0);
                R_Filtered2 := ((ln(exp(RedIn) / Gamma2)) * 10.0);
                G_Filtered := ((exp(ln(GreenIn) / Gamma)) * 10.0);
                G_Filtered2 := ((ln(exp(GreenIn) / Gamma2)) * 10.0);
                B_Filtered := ((exp(ln(BlueIn) / Gamma)) * 10.0);
                B_Filtered2 := ((ln(exp(BlueIn) / Gamma2)) * 10.0);
                R_Filtered := R_Filtered - R_Filtered2;
                G_Filtered := G_Filtered - G_Filtered2;
                B_Filtered := B_Filtered - B_Filtered2;
              end;

            3: begin
                R_Filtered := ((ln(exp(RedIn) / Gamma)) * 10.0);
                R_Filtered2 := ((exp(ln(RedIn) / Gamma2)) * 10.0);
                G_Filtered := ((ln(exp(GreenIn) / Gamma)) * 10.0);
                G_Filtered2 := ((exp(ln(GreenIn) / Gamma2)) * 10.0);
                B_Filtered := ((ln(exp(BlueIn) / Gamma)) * 10.0);
                B_Filtered2 := ((exp(ln(BlueIn) / Gamma2)) * 10.0);
                R_Filtered := R_Filtered - R_Filtered2;
                G_Filtered := G_Filtered - G_Filtered2;
                B_Filtered := B_Filtered - B_Filtered2;
              end;
          end; {of CASE}
          if V_Absolute then begin
            if R_Filtered < 0 then R_Filtered := (R_Filtered * -1);
            if G_Filtered < 0 then G_Filtered := (G_Filtered * -1);
            if B_Filtered < 0 then B_Filtered := (B_Filtered * -1);
          end;

          if AUTORANGE then begin
            if Range = 0 then begin
              if R_Filtered > R_Max then R_Max := R_Filtered;
              if G_Filtered > G_Max then G_Max := G_Filtered;
              if B_Filtered > B_Max then B_Max := B_Filtered;
              if R_Filtered < R_Min then R_Min := R_Filtered;
              if G_Filtered < G_Min then G_Min := G_Filtered;
              if B_Filtered < B_Min then B_Min := B_Filtered;
            end;
            if Range = 1 then begin
              R_Filtered := (R_Filtered - (R_Min)) / R_Range;
              G_Filtered := (G_Filtered - (G_Min)) / G_Range;
              B_Filtered := (B_Filtered - (B_Min)) / B_Range;
              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);

              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);

              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);

{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));}
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;

            end;
          end else
            if {Do_Absolute, AutoRange,}  Do_Ex_com
              {, ClipR, ThresholdR,}
            then begin {Jensen, p. 136}
              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));}
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;

            end else
              if {Do_Absolute, AutoRange, B_Ex_com}  BelowZero
                {, ClipR, ThresholdR,}
              then begin {Jensen, p. 136}
{       IF R_Filtered <= 0 then R_Filtered := (127+(R_Filtered*127) ) else
       IF R_Filtered > 0 then} R_Filtered := (127 + (R_Filtered *
                  127));
                if R_Filtered > 255 then R_Filtered := 255;
                if R_Filtered < 0 then R_Filtered := 0;
                RedColor := Round(R_Filtered);
{       IF G_Filtered <= 0 then G_Filtered := (127+(G_Filtered*127)) else
       IF G_Filtered > 0 then} G_Filtered := (127 + (G_Filtered *
                  127));
                if G_Filtered > 255 then G_Filtered := 255;
                if G_Filtered < 0 then G_Filtered := 0;
                GreenColor := Round(G_Filtered);
{       IF B_Filtered <= 0 then B_Filtered := (127+(B_Filtered*127)) else
       IF B_Filtered > 0 then} B_Filtered := (127 + (B_Filtered *
                  127));
                if B_Filtered > 255 then B_Filtered := 255;
                if B_Filtered < 0 then B_Filtered := 0;
                BlueColor := Round(B_Filtered);
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));}
                WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
                lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                lpPixelR^ := RedColor;

              end else
                if {Do_Absolute, AutoRange, B_Ex_com,}  ClipR
                  {, ThresholdR,}
                then begin {Jensen, p. 136}
                  if R_Filtered > 255 then R_Filtered := 255;
                  if R_Filtered < 0 then R_Filtered := 0;
                  RedColor := Round(R_Filtered);
                  if G_Filtered > 255 then G_Filtered := 255;
                  if G_Filtered < 0 then G_Filtered := 0;
                  GreenColor := Round(G_Filtered);
                  if B_Filtered > 255 then B_Filtered := 255;
                  if B_Filtered < 0 then B_Filtered := 0;
                  BlueColor := Round(B_Filtered);
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));}
                  WherePixel := ((IW * 3) + (IL * BytesPerLine));
                  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                  lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                    1];
                  lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                    2];
                  lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                  lpPixelR^ := RedColor;

                end;
        end; {OF WIDTH}
       {Place a Window Breather;
        and an Update IconWait message here}
        if (Range = 0) then
        begin
          Per_Done := Round(100 * (IL / (ImageHeight)));
          SetP_Done(1, Per_Done
            {inWindow: HWND; iPercentDone: integer}, All_Min,
              All_Max);
        end else
          if (Range = 1) then
          begin
            Per_Done := Round(100 * (IL / (ImageHeight)));
            SetP_Done(2, Per_Done
              {inWindow: HWND; iPercentDone: integer}, All_Min,
              All_Max);
          end else
          begin
            Per_Done := Round(100 * (IL / (ImageHeight)));
            SetP_Done1(Per_Done);
          end;
      end; {OF LENGTH}
    end; {of AutoRange}
{BlackOut;}
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
end; {of Gamma}
(******************************************************)

(******************************************************)

procedure DoContrast(AdjustValue: Integer);
var
  Red, Green, Blue: Integer;
  Where, Line, Row, Col: DWord;
begin
{$IFOPT R+}
{$DEFINE CKRANGE}
{$R-}
{$ENDIF}
  MakeImage;
  if ImageMade then begin
   // Calculate the address of row in image data
    for Row := 0 to ImageHeight do begin
      Line := (Row * BytesPerLine);
    // Calculate the address of desired pixel
      for Col := 0 to ImageWidth do begin
        Where := (Line + (Col * 3));
        lpPixelB := @PHugeByteArray(Image)^[Where];
        lpPixelG := @PHugeByteArray(Image)^[Where + 1];
        lpPixelR := @PHugeByteArray(Image)^[Where + 2];
{      AdjustValue := 55;}
        Blue := (lpPixelB^) + AdjustValue;
        Green := (lpPixelG^) + AdjustValue;
        Red := (lpPixelR^) + AdjustValue;
     // Range check calculated values
        if (Red < 0) then Red := 0;
        if (Red > 255) then Red := 255;
        if (Green < 0) then Green := 0;
        if (Green > 255) then Green := 255;
        if (Blue < 0) then Blue := 0;
        if (Blue > 255) then Blue := 255;
      // Store the new values back into the DIB
        lpPixelB^ := Blue;
        lpPixelG^ := Green;
        lpPixelR^ := Red;
      end; {Column ... Pixel} end; {line}
    SetImage;
  end;
{$IFDEF CKRANGE}
{$UNDEF CKRANGE}
{$R+}
{$ENDIF}
end; {of this}
(******************************************************)

procedure DoPixel;
var
  AdjustValue, Red, Green, Blue: Integer;
  Where, Line, Row, Col: DWord;
begin
{$IFOPT R+}
{$DEFINE CKRANGE}
{$R-}
{$ENDIF}
  MakeImage;
  if ImageMade then begin
   // Calculate the address of row in image data
    for Row := 0 to ImageHeight do begin
      Line := (Row * BytesPerLine);
    // Calculate the address of desired pixel
      for Col := 0 to ImageWidth do begin
        Where := (Line + (Col * 3));
        lpPixelB := @PHugeByteArray(Image)^[Where];
        lpPixelG := @PHugeByteArray(Image)^[Where + 1];
        lpPixelR := @PHugeByteArray(Image)^[Where + 2];
        AdjustValue := random(round(random) * 100) -
          random(round(random) * 100);
        Blue := (lpPixelB^) + AdjustValue;
        Green := (lpPixelG^) + AdjustValue;
        Red := (lpPixelR^) + AdjustValue;
     // Range check calculated values
        if (Red < 0) then Red := 0;
        if (Red > 255) then Red := 255;
        if (Green < 0) then Green := 0;
        if (Green > 255) then Green := 255;
        if (Blue < 0) then Blue := 0;
        if (Blue > 255) then Blue := 255;
      // Store the new values back into the DIB
        lpPixelB^ := Blue;
        lpPixelG^ := Green;
        lpPixelR^ := Red;
      end; {Column ... Pixel} end; {line}
    SetImage;
  end;
{$IFDEF CKRANGE}
{$UNDEF CKRANGE}
{$R+}
{$ENDIF}
end; {of Pixel}

(******************************************************)

(******************************************************)

procedure Do_PARBMultiply(dPARR1, dPARR2, dPARR3,
  dPARG1, dPARG2, dPARG3,
  dPARB1, dPARB2, dPARB3: Double; TypeOP: Integer);
var
  SpatError: Boolean;
  R_Min, G_Min, B_Min: Single;
  R_Range, R_Max, G_Range, G_Max, B_Range, B_Max,
    Ri, Gi, Bi, K_Filtered, R_Filtered, G_Filtered, B_Filtered:
  Double;
{  R_Hope, G_Hope, B_Hope,CenterPixel, TheColor:Longint;
  RCenter, GCenter, BCenter,}
  RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd, Range,
    AutoTimes, Center, Size, sX, sY, Where: Integer;
  IL, IW: DWord;
begin {Get current Window DC}
  AutoTimes := 0;
  if AUTORANGE then AutoTimes := 1;
  SpatError := FALSE;
  R_Max := 0;
  R_Min := 255;
  G_Max := 0;
  G_Min := 255;
  B_Max := 0;
  B_Min := 255;
     {Begin of Whole Autorange = True... Do Twice}
  ILStart := 0;
  IWStart := 0;
  ILEnd := (ImageHeight);
  IWEnd := (ImageWidth);
  MakeImage;
  if ImageMade = TRUE then begin
    for RANGE := 0 to AutoTimes do begin
      R_Range := R_Max - R_Min;
      R_Range := R_Range / 255;
      G_Range := G_Max - G_Min;
      G_Range := G_Range / 255;
      B_Range := B_Max - B_Min;
      B_Range := B_Range / 255;

      for IL := ILStart to ILEnd do begin
        if R_Max > All_Max then All_Max := R_Max;
        if G_Max > All_Max then All_Max := G_Max;
        if B_Max > All_Max then All_Max := B_Max;
        if R_Min < All_Min then All_Min := R_Min;
        if G_Min < All_Min then All_Min := G_Min;
        if B_Min < All_Min then All_Min := B_Min;
        for IW := IWStart to IWEnd do begin
          R_Filtered := 0;
          G_Filtered := 0;
          B_Filtered := 0;
          WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
          lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
          lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
          lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
          BlueColor := lpPixelB^;
          GreenColor := lpPixelG^;
          RedColor := lpPixelR^;
          case TypeOP of
            0: begin
                Bi := (BlueColor + dPARR1);
                Gi := (GreenColor + dPARR2);
                Ri := (RedColor + dPARR3);
                K_Filtered := (Bi + Gi);
                R_Filtered := (Ri + K_Filtered);
                Bi := (BlueColor + dPARG1);
                Gi := (GreenColor + dPARG2);
                Ri := (RedColor + dPARG3);
                K_Filtered := (Bi + Gi);
                G_Filtered := (Ri + K_Filtered);
                Bi := (BlueColor + dPARB1);
                Gi := (GreenColor + dPARB2);
                Ri := (RedColor + dPARB3);
                K_Filtered := (Bi + Gi);
                B_Filtered := (Ri + K_Filtered);
              end;
            1: begin
                Bi := (BlueColor - dPARR1);
                Gi := (GreenColor - dPARR2);
                Ri := (RedColor - dPARR3);
                K_Filtered := (Bi + Gi);
                R_Filtered := (Ri + K_Filtered);
                Bi := (BlueColor - dPARG1);
                Gi := (GreenColor - dPARG2);
                Ri := (RedColor - dPARG3);
                K_Filtered := (Bi + Gi);
                G_Filtered := (Ri + K_Filtered);
                Bi := (BlueColor - dPARB1);
                Gi := (GreenColor - dPARB2);
                Ri := (RedColor - dPARB3);
                K_Filtered := (Bi + Gi);
                B_Filtered := (Ri + K_Filtered);
              end;
            2: begin
                Bi := (BlueColor * dPARR1);
                Gi := (GreenColor * dPARR2);
                Ri := (RedColor * dPARR3);
                K_Filtered := (Bi + Gi);
                R_Filtered := (Ri + K_Filtered);
                Bi := (BlueColor * dPARG1);
                Gi := (GreenColor * dPARG2);
                Ri := (RedColor * dPARG3);
                K_Filtered := (Bi + Gi);
                G_Filtered := (Ri + K_Filtered);
                Bi := (BlueColor / dPARB1);
                Gi := (GreenColor / dPARB2);
                Ri := (RedColor / dPARB3);
                K_Filtered := (Bi + Gi);
                B_Filtered := (Ri + K_Filtered);
              end;
            3: begin
                Bi := (BlueColor / dPARR1);
                Gi := (GreenColor / dPARR2);
                Ri := (RedColor / dPARR3);
                K_Filtered := (Bi + Gi);
                R_Filtered := (Ri + K_Filtered);
                Bi := (BlueColor / dPARG1);
                Gi := (GreenColor / dPARG2);
                Ri := (RedColor / dPARG3);
                K_Filtered := (Bi + Gi);
                G_Filtered := (Ri + K_Filtered);
                Bi := (BlueColor / dPARB1);
                Gi := (GreenColor / dPARB2);
                Ri := (RedColor / dPARB3);
                K_Filtered := (Bi + Gi);
                B_Filtered := (Ri + K_Filtered);
              end;

          end; {of Case}
          if AUTORANGE then begin
            if Range = 0 then begin
              if R_Filtered > R_Max then R_Max := R_Filtered;
              if G_Filtered > G_Max then G_Max := G_Filtered;
              if B_Filtered > B_Max then B_Max := B_Filtered;
              if R_Filtered < R_Min then R_Min := R_Filtered;
              if G_Filtered < G_Min then G_Min := G_Filtered;
              if B_Filtered < B_Min then B_Min := B_Filtered;
            end;
            if Range = 1 then begin
(*       R_Filtered :=  (R_Filtered+{ABS}(R_Min))/R_Range;
       G_Filtered :=  (G_Filtered+{ABS}(G_Min))/G_Range;
       B_Filtered :=  (B_Filtered+{ABS}(B_Min))/B_Range;
*)
              R_Filtered := ((R_Filtered - (R_Min)) / R_Range);
              G_Filtered := ((G_Filtered - (G_Min)) / G_Range);
              B_Filtered := ((B_Filtered - (B_Min)) / B_Range);

              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);

{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));}
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;

            end;
          end else
            if {Do_Absolute, AutoRange, B_Ex_com}  BelowZero
              {, ClipR, ThresholdR,}
            then begin {Jensen, p. 136}
{       IF R_Filtered <= 0 then R_Filtered := (127+(R_Filtered*127) ) else
       IF R_Filtered > 0 then} R_Filtered := (127 + (R_Filtered *
                127));
              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);
{       IF G_Filtered <= 0 then G_Filtered := (127+(G_Filtered*127)) else
       IF G_Filtered > 0 then} G_Filtered := (127 + (G_Filtered *
                127));
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);
{       IF B_Filtered <= 0 then B_Filtered := (127+(B_Filtered*127)) else
       IF B_Filtered > 0 then} B_Filtered := (127 + (B_Filtered *
                127));
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));}
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;

            end else
              if {Do_Absolute, AutoRange, }  Do_Ex_com
                {, ClipR, ThresholdR,}
              then begin {Jensen, p. 136}
                if R_Filtered < 1 then
                  R_Filtered := ((R_Filtered * 127) + 1) else
                  if R_Filtered >= 1 then
                    R_Filtered := (128 + (R_Filtered / 2));
                if R_Filtered > 255 then R_Filtered := 255;
                if R_Filtered < 0 then R_Filtered := 0;
                RedColor := Round(R_Filtered);
                if G_Filtered < 1 then
                  G_Filtered := ((G_Filtered * 127) + 1) else
                  if G_Filtered >= 1 then
                    G_Filtered := (128 + (G_Filtered / 2));
                if G_Filtered > 255 then G_Filtered := 255;
                if G_Filtered < 0 then G_Filtered := 0;
                GreenColor := Round(G_Filtered);
                if B_Filtered < 1 then
                  B_Filtered := ((B_Filtered * 127) + 1) else
                  if B_Filtered >= 1 then
                    B_Filtered := (128 + (B_Filtered / 2));
                if B_Filtered > 255 then B_Filtered := 255;
                if B_Filtered < 0 then B_Filtered := 0;
                BlueColor := Round(B_Filtered);
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));}
                WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
                lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                lpPixelR^ := RedColor;

              end else
                if {Do_Absolute, AutoRange, B_Ex_com,}  ClipR
                  {, ThresholdR,}
                then begin {Jensen, p. 136}
                  if R_Filtered > 255 then R_Filtered := 255;
                  if R_Filtered < 0 then R_Filtered := 0;
                  RedColor := Round(R_Filtered);
                  if G_Filtered > 255 then G_Filtered := 255;
                  if G_Filtered < 0 then G_Filtered := 0;
                  GreenColor := Round(G_Filtered);
                  if B_Filtered > 255 then B_Filtered := 255;
                  if B_Filtered < 0 then B_Filtered := 0;
                  BlueColor := Round(B_Filtered);
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));}
                  WherePixel := ((IW * 3) + (IL * BytesPerLine));
                  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                  lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                    1];
                  lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                    2];
                  lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                  lpPixelR^ := RedColor;

                end; { of AutoRange Insider Edition}
        end; {of  Image Width}
       {Place a Window Breather;
        and an Update IconWait message here}
        if AutoRange then begin
          if (Range = 0) then
          begin
            Per_Done := Round(100 * (IL / (ImageHeight)));
            SetP_Done(1, Per_Done
              {inWindow: HWND; iPercentDone: integer}, All_Min,
              All_Max);
          end else
            if (Range = 1) then
            begin
              Per_Done := Round(100 * (IL / (ImageHeight)));
              SetP_Done(2, Per_Done
                {inWindow: HWND; iPercentDone: integer}, All_Min,
                All_Max);
            end
        end else
        begin
          Per_Done := Round(100 * (IL / (ImageHeight)));
          SetP_Done1(Per_Done);
        end;
      end; {of Image Length}
    end; {of AutoRange}
{BlackOut;}
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
end; {of Pixel Mnamymultiples}
(******************************************************)

(******************************************************)
(******************************************************)

procedure Do_PMultiply(RedPixel, GreenPixel, BluePixel: Double;
  TypeOP: Integer);
var
  SpatError: Boolean;
  R_Min, G_Min, B_Min: Single;
  R_Range, R_Max, G_Range, G_Max, B_Range, B_Max,
    Ri, Gi, Bi, K_Filtered, R_Filtered, G_Filtered, B_Filtered:
  Double;
  R_Hope, G_Hope, B_Hope, CenterPixel, TheColor: Longint;
  RCenter, GCenter, BCenter,
    RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd, Range,
    AutoTimes, Center, Size, sX, sY, Where: Integer;
  IL, IW: DWord;
begin {Get current Window DC}
  AutoTimes := 0;
  if AUTORANGE then AutoTimes := 1;
  SpatError := FALSE;
  R_Max := 0;
  R_Min := 255;
  G_Max := 0;
  G_Min := 255;
  B_Max := 0;
  B_Min := 255;
     {Begin of Whole Autorange = True... Do Twice}
  ILStart := 0;
  IWStart := 0;
  ILEnd := (ImageHeight);
  IWEnd := (ImageWidth);
  MakeImage;
  if ImageMade = TRUE then begin
    for RANGE := 0 to AutoTimes do begin
      R_Range := R_Max - R_Min;
      R_Range := R_Range / 255;
      G_Range := G_Max - G_Min;
      G_Range := G_Range / 255;
      B_Range := B_Max - B_Min;
      B_Range := B_Range / 255;

      for IL := ILStart to ILEnd do begin
        if R_Max > All_Max then All_Max := R_Max;
        if G_Max > All_Max then All_Max := G_Max;
        if B_Max > All_Max then All_Max := B_Max;
        if R_Min < All_Min then All_Min := R_Min;
        if G_Min < All_Min then All_Min := G_Min;
        if B_Min < All_Min then All_Min := B_Min;
        for IW := IWStart to IWEnd do begin
          R_Filtered := 0;
          G_Filtered := 0;
          B_Filtered := 0;
       {  TheColor:= GetPixel(hUnDoDC,(IW),(IL));
         RedColor:= GetRValue(TheColor);
         GreenColor:= GetGValue(TheColor);
         BlueColor:= GetBValue(TheColor);}
          WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
          lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
          lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
          lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
          BlueColor := lpPixelB^;
          GreenColor := lpPixelG^;
          RedColor := lpPixelR^;
          case TypeOP of
            0: begin
                R_Filtered := (RedColor + RedPixel);
                G_Filtered := (GreenColor + GreenPixel);
                B_Filtered := (BlueColor + BluePixel);
              end;
            1: begin
                R_Filtered := (RedColor - RedPixel);
                G_Filtered := (GreenColor - GreenPixel);
                B_Filtered := (BlueColor - BluePixel);
              end;
            2: begin
                R_Filtered := (RedColor * RedPixel);
                G_Filtered := (GreenColor * GreenPixel);
                B_Filtered := (BlueColor * BluePixel);
              end;
            3: begin
                R_Filtered := (RedColor / RedPixel);
                G_Filtered := (GreenColor / GreenPixel);
                B_Filtered := (BlueColor / BluePixel);
              end;
          end; {of case}
          if AUTORANGE then begin
            if Range = 0 then begin
              if R_Filtered > R_Max then R_Max := R_Filtered;
              if G_Filtered > G_Max then G_Max := G_Filtered;
              if B_Filtered > B_Max then B_Max := B_Filtered;
              if R_Filtered < R_Min then R_Min := R_Filtered;
              if G_Filtered < G_Min then G_Min := G_Filtered;
              if B_Filtered < B_Min then B_Min := B_Filtered;
            end;
            if Range = 1 then begin
(*       R_Filtered :=  (R_Filtered+{ABS}(R_Min))/R_Range;
       G_Filtered :=  (G_Filtered+{ABS}(G_Min))/G_Range;
       B_Filtered :=  (B_Filtered+{ABS}(B_Min))/B_Range;
*)
              R_Filtered := ((R_Filtered - (R_Min)) / R_Range);
              G_Filtered := ((G_Filtered - (G_Min)) / G_Range);
              B_Filtered := ((B_Filtered - (B_Min)) / B_Range);

              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);

{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));}
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;

            end;
          end else
            if {Do_Absolute, AutoRange, B_Ex_com}  BelowZero
              {, ClipR, ThresholdR,}
            then begin {Jensen, p. 136}
{       IF R_Filtered <= 0 then R_Filtered := (127+(R_Filtered*127) ) else
       IF R_Filtered > 0 then} R_Filtered := (127 + (R_Filtered *
                127));
              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);
{       IF G_Filtered <= 0 then G_Filtered := (127+(G_Filtered*127)) else
       IF G_Filtered > 0 then} G_Filtered := (127 + (G_Filtered *
                127));
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);
{       IF B_Filtered <= 0 then B_Filtered := (127+(B_Filtered*127)) else
       IF B_Filtered > 0 then} B_Filtered := (127 + (B_Filtered *
                127));
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));}
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;

            end else
              if {Do_Absolute, AutoRange, }  Do_Ex_com
                {, ClipR, ThresholdR,}
              then begin {Jensen, p. 136}
                if R_Filtered < 1 then
                  R_Filtered := ((R_Filtered * 127) + 1) else
                  if R_Filtered >= 1 then
                    R_Filtered := (128 + (R_Filtered / 2));
                if R_Filtered > 255 then R_Filtered := 255;
                if R_Filtered < 0 then R_Filtered := 0;
                RedColor := Round(R_Filtered);
                if G_Filtered < 1 then
                  G_Filtered := ((G_Filtered * 127) + 1) else
                  if G_Filtered >= 1 then
                    G_Filtered := (128 + (G_Filtered / 2));
                if G_Filtered > 255 then G_Filtered := 255;
                if G_Filtered < 0 then G_Filtered := 0;
                GreenColor := Round(G_Filtered);
                if B_Filtered < 1 then
                  B_Filtered := ((B_Filtered * 127) + 1) else
                  if B_Filtered >= 1 then
                    B_Filtered := (128 + (B_Filtered / 2));
                if B_Filtered > 255 then B_Filtered := 255;
                if B_Filtered < 0 then B_Filtered := 0;
                BlueColor := Round(B_Filtered);
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));}
                WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
                lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                lpPixelR^ := RedColor;

              end else
                if {Do_Absolute, AutoRange, B_Ex_com,}  ClipR
                  {, ThresholdR,}
                then begin {Jensen, p. 136}
                  if R_Filtered > 255 then R_Filtered := 255;
                  if R_Filtered < 0 then R_Filtered := 0;
                  RedColor := Round(R_Filtered);
                  if G_Filtered > 255 then G_Filtered := 255;
                  if G_Filtered < 0 then G_Filtered := 0;
                  GreenColor := Round(G_Filtered);
                  if B_Filtered > 255 then B_Filtered := 255;
                  if B_Filtered < 0 then B_Filtered := 0;
                  BlueColor := Round(B_Filtered);
{       SetPixel(hWorkDC, IW, IL,RGB(RedColor, GreenColor, BlueColor));}
                  WherePixel := ((IW * 3) + (IL * BytesPerLine));
                  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                  lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                    1];
                  lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                    2];
                  lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                  lpPixelR^ := RedColor;

                end; { of AutoRange Insider Edition}
        end; {of  Image Width}

        if AutoRange then begin
          if (Range = 0) then
          begin
            Per_Done := Round(100 * (IL / (ImageHeight)));
            SetP_Done(1, Per_Done
              {inWindow: HWND; iPercentDone: integer}, All_Min,
              All_Max);
          end else
            if (Range = 1) then
            begin
              Per_Done := Round(100 * (IL / (ImageHeight)));
              SetP_Done(2, Per_Done
                {inWindow: HWND; iPercentDone: integer}, All_Min,
                All_Max);
            end
        end else
        begin
          Per_Done := Round(100 * (IL / (ImageHeight)));
          SetP_Done1(Per_Done);
        end;
      end; {of Image Length}
    end; {of AutoRange}
{BlackOut;}
    SetImage;
{IF DeleteBitmap <> TRUE THEN Do_Error(1227,1229);}
  end; {OF MAKE BITMAP}
{SetFileName(FileName);}
end; {of Pixel Multipilier}
(******************************************************)




end.
